// WHEEL OF DISCIPLINE (PRIZE WHEEL/QUIZ GAME)
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 1.10
//
// CREDITS:
// Script by Banjo. Thanks to Marspank, Liz and Doti for their additional code and help.
// Inspired by the Pacific Force spanking video series 'Wheel of Discipline'.
// Opponent images sourced from various free web preview galleries.
// Spanking sounds recorded and edited by Banjo.
// Wheel sounds from www.freesound.org, edited by Banjo from sounds originally recorded by Tony Bear.
// Buzzer sound from www.freesound.org, originally recorded by Kwahmah-02.
// Score sound from www.freesound.org, originally recorded by JustinBW.
// Bankrupt ("sad trombone") sound from www.freesound.org, originally recorded by KirbyDX.
// The majority of trivia questions were sourced from www.triviaplaying.com.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/wheelofdiscipline.groovy
 * scripts/Banjo/Quiz/*.txt
 */
//

//Metadata
setInfos(7, "Wheel of Discipline",
	"A spanking prize wheel and quiz game (requires Game Hub)",
	"Banjo",
	"v1.10", 0xFFFFFF, "en",
	["spanking", "game", "femaledom", "formale", "forfemale", "banjohub"]);

//Player setup
def player = (loadString("intro.name"))
def manlady = "man"
def boygirl = "boy"
def bratbitch = "brat"
def cockpussy = "cock"
if(loadBoolean("intro.female"))
{
	manlady = "lady"
	boygirl = "girl"
	bratbitch = "bitch"
	cockpussy = "pussy"
}

//Game Setup
def gamename = "Wheel of Discipline"
def opponent_met = false
def opponent_played = false
def menu = 0
def quit = false
def greeting = "Ready to play?"
def gameMode = 0
def safeChance = true
def wheelTotalSpinsFixed = 3
def wheelTotalSpinsMin = 2
def wheelTotalSpinsMax = 6
def wheelTotalSpinsRandom = true
def bonusSpinChance = 1
def bonusRoundChance = 1
def bonusMultiplier = 2
def gameRoundsMax = 5
def gamePointsRound = 20
def categoryMode = false
def pickCategory = true
def bankruptMode = false

//Load Settings
def loadSettings = {
	if(loadBoolean("Banjo.wheelofdiscipline.custom")) {
		safeChance = loadBoolean("Banjo.wheelofdiscipline.safeChance")
		wheelTotalSpinsFixed = loadInteger("Banjo.wheelofdiscipline.wheelTotalSpinsFixed")
		wheelTotalSpinsMin = loadInteger("Banjo.wheelofdiscipline.wheelTotalSpinsMin")
		wheelTotalSpinsMax = loadInteger("Banjo.wheelofdiscipline.wheelTotalSpinsMax")
		wheelTotalSpinsRandom = loadBoolean("Banjo.wheelofdiscipline.wheelTotalSpinsRandom")
		bonusSpinChance = loadInteger("Banjo.wheelofdiscipline.bonusSpinChance")
		bonusRoundChance = loadInteger("Banjo.wheelofdiscipline.bonusRoundChance")
		gameRoundsMax = loadInteger("Banjo.wheelofdiscipline.gameRoundsMax")
		gamePointsRound = loadInteger("Banjo.wheelofdiscipline.gamePointsRound")
		categoryMode = loadBoolean("Banjo.wheelofdiscipline.categoryMode")
		pickCategory = loadBoolean("Banjo.wheelofdiscipline.pickCategory")
		bankruptMode = loadBoolean("Banjo.wheelofdiscipline.bankruptMode")
	}
}

//Default implements
def spinImplement = "hairbrush"
def spinImplementSound = "smack"

def slot1Implement = "hairbrush"
def slot1ImplementSound = "smack"
def slot1Swats1 = 20
def slot1Swats2 = 30
def slot1Swats3 = 50
def slot2Implement = "strap"
def slot2ImplementSound = "belt"
def slot2Swats1 = 10
def slot2Swats2 = 20
def slot3Implement = "slipper"
def slot3ImplementSound = "smack"
def slot3Swats1 = 50
def slot3Swats2 = 75
def slot4Implement = "cane"
def slot4ImplementSound = "thwack"
def slot4Swats1 = 3
def slot4Swats2 = 6
def slot5Implement = "wooden spoon"
def slot5ImplementSound = "whap"
def slot5Swats1 = 15
def slot5Swats2 = 25
def slot6Implement = "paddle"
def slot6ImplementSound = "whack"
def slot6Swats1 = 20
def slot6Swats2 = 25
def slot7Implement = "paddle with holes"
def slot7ImplementSound = "whack"
def slot7Swats1 = 15
def slot7Swats2 = 20
def slot8Implement = "slipper"
def slot8ImplementSound = "smack"
def slot8Swats1 = 25
def slot8Swats2 = 50
def slot9Implement = "paddle"
def slot9ImplementSound = "whack"
def slot9Swats1 = 10
def slot9Swats2 = 15

//Default opponent
def opponent="Gemma"
def opponent_pics = 5
def opponent_pics2 = 2
def respectTitle = "Miss"
def meet1 = "Hi, I'm "+opponent+"."
def meet2 = "\n\nWhat's your name?"
def meet3 = "It's nice to meet you, "+player+"."
def meet4 = "Let's play '"+gamename+"'."
def intro1 = "Hi there!\n\nLet's play '"+gamename+"'."
def backagain1 = "Want to play '"+gamename+"' with me again?"
def backagain2 = "Back for another game of '"+gamename+"'?"
def refuse1 = "Aww, too bad!\n\nMaybe some other time?"
def goodbye1 = "Now wasn't that a fun game?\n\nCome back soon so we can play again."

//Opponents
def maxOpponents = 13
def opponent0 = "Gemma"
def opponent1 = "Sandy"
def opponent2 = "Khyanna"
def opponent3 = "Raven"
def opponent4 = "Nicole"
def opponent5 = "Gracie"
def opponent6 = "Melanie"
def opponent7 = "Ann"
def opponent8 = "Valentina"
def opponent9 = "Kitty"
def opponent10 = "Bryci"
def opponent11 = "Tyler"
def opponent12 = "Tere"
def opponent13 = "Kiara"

def opponentSet0 = {
	opponent = "Gemma"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet1 = {
	opponent = "Sandy"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet2 =  {
	opponent = "Khyanna"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet3 = 	{
	opponent = "Raven"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet4 = {
	opponent = "Nicole"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet5 = {
	opponent = "Gracie"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet6 = {
	opponent = "Melanie"
	respectTitle = "Miss"
	opponent_pics = 6
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}


def opponentSet7 = {
	opponent = "Ann"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet8 = {
	opponent = "Valentina"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet9 = {
	opponent = "Kitty"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	meet1 = "My name is "+opponent+"."
	meet2 = "\n\nWho the hell are you, "+bratbitch+"?"
	meet3 = "Hmph! Another silly little "+boygirl+"?"
	meet4 = "I assume you want to play '"+gamename+"' with me?"
	intro1 = "Hello, "+boygirl+"\n\nShall we play '"+gamename+"'?"
	backagain1 = "Do you want to play '"+gamename+"' again?"
	backagain2 = "Back for another game of '"+gamename+"', "+boygirl+"?"
	refuse1 = "Then run along and don't bother me, little "+boygirl+"."
	goodbye1 = "That was rather amusing.\n\nI might enjoy playing with you again."
}

def opponentSet10 = {
	opponent = "Bryci"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 3
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet11 = {
	opponent = "Tyler"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet12 = {
	opponent = "Tere"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet13 = {
	opponent = "Kiara"
	respectTitle = "Aunty"
	opponent_pics = 7
	opponent_pics2 = 4
	meet1 = "Hello there. I'm "+opponent+"... but you can call me '"+respectTitle+" "+opponent+"', young "+manlady+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

//Opponent selection menu
def opponentSelect = {
	def opponentselection = true
	while(opponentselection)
	{
		def pick_opponent = getSelectedValue("Select your opponent:", [opponent0,opponent1,opponent2,opponent3,opponent4,opponent5,opponent6,opponent7,opponent8,opponent9,opponent10,opponent11,opponent12,opponent13])
		if(pick_opponent==0) opponentSet0()
		else if(pick_opponent==1) opponentSet1()
		else if(pick_opponent==2) opponentSet2()
		else if(pick_opponent==3) opponentSet3()
		else if(pick_opponent==4) opponentSet4()
		else if(pick_opponent==5) opponentSet5()
		else if(pick_opponent==6) opponentSet6()
		else if(pick_opponent==7) opponentSet7()
		else if(pick_opponent==8) opponentSet8()
		else if(pick_opponent==9) opponentSet9()
		else if(pick_opponent==10) opponentSet10()
		else if(pick_opponent==11) opponentSet11()
		else if(pick_opponent==12) opponentSet12()
		else if(pick_opponent==13) opponentSet13()
		if(pick_opponent<(maxOpponents+1)) opponentselection = false
	}
}

//Config menu
def setCustom = {
	safeChance = getBoolean("Do you want to have a 'safe' slot on the Wheel (if spun, you escape being spanked)?\n\n(default is Yes)", "Yes", "No")
	wheelTotalSpinsRandom = getBoolean("Do you want the number of spins you must make in Punishment Mode to be random or fixed?\n\n(default is Random)", "Random", "Fixed")
	if(wheelTotalSpinsRandom) {
		wheelTotalSpinsMin = getInteger("Enter the minimum number of spins you must make in Punishment Mode.\n\n(default is 3, current is "+wheelTotalSpinsMin+")",wheelTotalSpinsMin)
		while(wheelTotalSpinsMin<1) {
			wheelTotalSpinsMin = getInteger("You must set the minimum number of spins to at least 1.\n\n(default is 3)",wheelTotalSpinsMin)
		}
		wheelTotalSpinsMax = getInteger("Enter the maximum number of spins you must make in Punishment Mode.\n\n(default is 6, current is "+wheelTotalSpinsMax+")",wheelTotalSpinsMax)
		while(wheelTotalSpinsMax<=wheelTotalSpinsMin) {
			wheelTotalSpinsMax = getInteger("You must set the maximum spins higher than the minimum.\n\n(default is 6)",wheelTotalSpinsMax)
		}
	}
	else {
		wheelTotalSpinsFixed = getInteger("Enter the number of spins you must make in Punishment Mode.\n\n(default is 3, current is "+wheelTotalSpinsFixed+")",wheelTotalSpinsFixed)
		while(wheelTotalSpinsFixed<1) {
			wheelTotalSpinsFixed = getInteger("You must set the number of spins to at least 1.\n\n(default is 3)",wheelTotalSpinsFixed)
		}
	}
	bonusSpinChance = getInteger("Enter the chance of having to make a bonus spin (out of 5) in Punishment Mode.\n\n(default is 1, current is "+bonusSpinChance+")",bonusSpinChance)
	while(bonusSpinChance>4) {
		bonusSpinChance = getInteger("You must set the number of spins to less than 5.\n\n(default is 1)",bonusSpinChance)
	}
	gameRoundsMax = getInteger("Enter the number of rounds to play in Game Mode.\n\n(default is 5, current is "+gameRoundsMax+")",gameRoundsMax)
	while(gameRoundsMax<3) {
		gameRoundsMax = getInteger("You must play 3 or more rounds.\n\n(default is 5)",gameRoundsMax)
	}
	gamePointsRound = getInteger("Enter the number of points you can win per round in Game Mode.\n\n(default is 20, current is "+gamePointsRound+")",gamePointsRound)
	while(gamePointsRound<1) {
		gamePointsRound = getInteger("You must set the points you can win to at least 1.\n\n(default is 20)",gamePointsRound)
	}
	bonusRoundChance = getInteger("Enter the chance of getting a bonus round (out of 5) in either Mode.\n\n(default is 1, current is "+bonusRoundChance+")",bonusRoundChance)
	while(bonusRoundChance>4) {
		bonusRoundChance = getInteger("You must set the number of spins to less than 5.\n\n(default is 1)",bonusRoundChance)
	}
	bonusMultiplier = getInteger("Enter the spank multiplier for bonus rounds in either Mode.\n\n(default is 2, current is "+bonusMultiplier+")",bonusMultiplier)
	while(bonusMultiplier<2) {
		bonusMultiplier = getInteger("You must set the multiplier to 2 or greater.\n\n(default is 2)",bonusMultiplier)
	}
	categoryMode = getBoolean("In Game Mode, do you want to be asked random questions, or only questions from a specific category?\n\n(default is Random)", "Category", "Random")
	if(categoryMode)
		pickCategory = getBoolean("In Game Mode, do you want to be asked to choose a category for questions, or have one randomly chosen?\n\n(default is Choose)", "Choose", "Random")
	bankruptMode = getBoolean("In Game Mode, do you want to lose all your points when you get a question wrong?\n\n(default is No)", "Yes", "No")
	save("Banjo.wheelofdiscipline.safeChance",safeChance)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsRandom",wheelTotalSpinsRandom)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsFixed",wheelTotalSpinsFixed)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMin",wheelTotalSpinsMin)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMax",wheelTotalSpinsMax)
	save("Banjo.wheelofdiscipline.bonusSpinChance",bonusSpinChance)
	save("Banjo.wheelofdiscipline.gameRoundsMax",gameRoundsMax)
	save("Banjo.wheelofdiscipline.gamePointsRound",gamePointsRound)
	save("Banjo.wheelofdiscipline.bonusRoundChance",bonusRoundChance)
	save("Banjo.wheelofdiscipline.bonusMultiplier",bonusMultiplier)
	save("Banjo.wheelofdiscipline.categoryMode",categoryMode)
	save("Banjo.wheelofdiscipline.pickCategory",pickCategory)
	save("Banjo.wheelofdiscipline.bankruptMode",bankruptMode)
	save("Banjo.wheelofdiscipline.custom",true)
	show("Settings saved.")
	wait(3)
	loadSettings()
}

def resetGame = {
	safeChance = true
	wheelTotalSpinsRandom = true
	wheelTotalSpinsFixed = 3
	wheelTotalSpinsMin = 2
	wheelTotalSpinsMax = 6
	bonusSpinChance = 1
	gameRoundsMax = 5
	gamePointsRound = 20
	bonusRoundChance = 1
	bonusMultiplier = 2
	categoryMode = false
	pickCategory = true
	bankruptMode = false
	opponent_played = false
	save("Banjo.wheelofdiscipline.implements_set",false)
	save("Banjo.wheelofdiscipline.safeChance",safeChance)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsRandom",wheelTotalSpinsRandom)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsFixed",wheelTotalSpinsFixed)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMin",wheelTotalSpinsMin)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMax",wheelTotalSpinsMax)
	save("Banjo.wheelofdiscipline.bonusSpinChance",bonusSpinChance)
	save("Banjo.wheelofdiscipline.gameRoundsMax",gameRoundsMax)
	save("Banjo.wheelofdiscipline.gamePointsRound",gamePointsRound)
	save("Banjo.wheelofdiscipline.bonusRoundChance",bonusRoundChance)
	save("Banjo.wheelofdiscipline.bonusMultiplier",bonusMultiplier)
	save("Banjo.wheelofdiscipline.categoryMode",categoryMode)
	save("Banjo.wheelofdiscipline.pickCategory",pickCategory)
	save("Banjo.wheelofdiscipline.bankruptMode",bankruptMode)
	save("Banjo.wheelofdiscipline.custom",false)
	save("Banjo.wheelofdiscipline.customwheel",false)
	save("Banjo.wheelofdiscipline.played_"+opponent0+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent1+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent2+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent3+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent4+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent5+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent6+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent7+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent8+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent9+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent10+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent11+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent12+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent13+"",opponent_played)
	show("Settings reset to defaults.\n\nGame will quit after exiting config.")
	wait(5)
	quit = true
}

def resetTotal = {
	safeChance = true
	wheelTotalSpinsRandom = true
	wheelTotalSpinsFixed = 3
	wheelTotalSpinsMin = 2
	wheelTotalSpinsMax = 6
	bonusSpinChance = 1
	gameRoundsMax = 5
	gamePointsRound = 20
	bonusRoundChance = 1
	bonusMultiplier = 2
	categoryMode = false
	pickCategory = true
	bankruptMode = false
	opponent_met = false
	opponent_played = false
	save("Banjo.wheelofdiscipline.implements_set",false)
	save("Banjo.wheelofdiscipline.safeChance",safeChance)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsRandom",wheelTotalSpinsRandom)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsFixed",wheelTotalSpinsFixed)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMin",wheelTotalSpinsMin)
	save("Banjo.wheelofdiscipline.wheelTotalSpinsMax",wheelTotalSpinsMax)
	save("Banjo.wheelofdiscipline.bonusSpinChance",bonusSpinChance)
	save("Banjo.wheelofdiscipline.gameRoundsMax",gameRoundsMax)
	save("Banjo.wheelofdiscipline.gamePointsRound",gamePointsRound)
	save("Banjo.wheelofdiscipline.bonusRoundChance",bonusRoundChance)
	save("Banjo.wheelofdiscipline.bonusMultiplier",bonusMultiplier)
	save("Banjo.wheelofdiscipline.categoryMode",categoryMode)
	save("Banjo.wheelofdiscipline.pickCategory",pickCategory)
	save("Banjo.wheelofdiscipline.bankruptMode",bankruptMode)
	save("Banjo.wheelofdiscipline.custom",false)
	save("Banjo.wheelofdiscipline.customwheel",false)
	save("Banjo.wheelofdiscipline.played_"+opponent0+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent1+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent2+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent3+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent4+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent5+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent6+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent7+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent8+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent9+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent10+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent11+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent12+"",opponent_played)
	save("Banjo.wheelofdiscipline.played_"+opponent13+"",opponent_played)
	save("Banjo.games.met_"+opponent0+"",opponent_met)
	save("Banjo.games.met_"+opponent1+"",opponent_met)
	save("Banjo.games.met_"+opponent2+"",opponent_met)
	save("Banjo.games.met_"+opponent3+"",opponent_met)
	save("Banjo.games.met_"+opponent4+"",opponent_met)
	save("Banjo.games.met_"+opponent5+"",opponent_met)
	save("Banjo.games.met_"+opponent6+"",opponent_met)
	save("Banjo.games.met_"+opponent7+"",opponent_met)
	save("Banjo.games.met_"+opponent8+"",opponent_met)
	save("Banjo.games.met_"+opponent9+"",opponent_met)
	save("Banjo.games.met_"+opponent10+"",opponent_met)
	save("Banjo.games.met_"+opponent11+"",opponent_met)
	save("Banjo.games.met_"+opponent12+"",opponent_met)
	save("Banjo.games.met_"+opponent13+"",opponent_met)
	show("Settings reset to defaults.")
	wait(5)
	quit = true
}

def changeSettings = {
	def loopmenu = true
	while(loopmenu) {
		menu = getSelectedValue("What do you want to do?", ["Exit Config", "Customize", "Reset Game", "Total Reset"])
		if(menu==0) loopmenu = false
		else if(menu==1) setCustom()
		else if(menu==2) resetGame()
		else if(menu==3) resetTotal()
	}
}

//Wheel Sounds
def playSoundWheelSpin = {
	playSound("banjo/gameshow/wheel_spin"+(1+getRandom(3))+".wav")
}

//Quiz Sounds
def playSoundCorrect = {
	playBackgroundSound("banjo/gameshow/quiz_correct.wav")
}
def playSoundWrong = {
	playBackgroundSound("banjo/gameshow/quiz_incorrect.wav")
}
def playSoundScore = {
	playBackgroundSound("banjo/gameshow/quiz_score.wav")
}
def playSoundBankrupt = {
	playBackgroundSound("banjo/gameshow/quiz_loser.wav")
}

//Basic variables and definitions
def wheelTotalSpins = 0
def wheelSpins = 0
def spinSpanks = 20
def totalSpanks = spinSpanks
def bonusRound = false
def losingRound = false
def doubleMultiplier = bonusMultiplier + bonusMultiplier

def gameRound = 0
def points = 0
def correct = false

int questionLimit
def questionArray
def answerArray

def tauntPre
def tauntPost
def tauntSpin
def tauntSpank

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}

def spankImplement = spinImplement
def spankSound = spinImplementSound
def spankSoundLimit = 4

def x = 0
def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(2)
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("spanks/"+spankSound+(1+getRandom(spankSoundLimit))+".wav")
		wait(time)
	}
	wait(5)
	x = 0
}

def stroke = {
	message, strokes, time ->
	show(""+message+"\n\n. . ")
	wait(time)
	(1..strokes).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("tom.wav")
		wait(time)
	}
}

//Randomly select an image
def setImageGame = {
	def imageNumber = getRandom(opponent_pics)+1
	setImage("opponents/"+opponent+"_playing"+imageNumber+".jpg")
}

def setImageSpank = {
	def imageNumber = getRandom(opponent_pics2)+1
	setImage("opponents/"+opponent+"_spank"+imageNumber+".jpg")
}

//Show main opponent image
def setImageMain = {
	setImage("opponents/"+opponent+"_intro.jpg")
}

//Game Intro
def intro = {
	if(!loadBoolean("Banjo.games.met_"+opponent+"")) {
		opponent_met = false
		save("Banjo.games.met_"+opponent+"",true)
	} else opponent_met = true
	if(!loadBoolean("Banjo.wheelofdiscipline.played_"+opponent+"")) {
		opponent_played = false
		save("Banjo.wheelofdiscipline.played_"+opponent+"",true)
	} else opponent_played = true
	if(!opponent_met) {
		show(meet1+meet2)
		showButton("I'm "+player+", "+respectTitle+".")
		show(meet3)
		wait(3)
		greeting = meet4
	} else if(!opponent_played) {
		greeting = intro1
	} else {
		def backagainMessageArray = [backagain1,backagain2]
		greeting = backagainMessageArray[getRandom(2)]
	}
	def mainmenu = true
	while(mainmenu) {
		loadSettings()
		menu = getSelectedValue(greeting, ["Yes", "No", "Config"])
		if(menu==0)
			mainmenu = false
		else if(menu==1) {
			show(refuse1)
			wait(5)
			mainmenu = false
			quit = true
		}
		else if(menu==2)
			changeSettings()
	}
}

//Rules explaination
def rulesDisplay = {
	if(gameMode==1) {
		show("'"+gamename+"' is a spanking game where spinning a prize wheel determines your penalties.")
		showButton("Sounds interesting, "+respectTitle+".")
		if(wheelTotalSpinsRandom)
			show("In Punishment Mode, you will spin the Wheel of Discipline between "+wheelTotalSpinsMin+" and "+wheelTotalSpinsMax+" times.")
		else
			show("In Punishment Mode, you will spin the Wheel of Discipline "+wheelTotalSpinsFixed+" times.")
		showButton("Yes, "+respectTitle+".")
		show("Each spin will tell you the implement you will be spanked with (the wheel's outer ring), "
			+"and how many spanks you will receive (the wheel's inner ring).")
		showButton("I understand, "+respectTitle+".")
		show("You will receive your spanks after each spin.\n\nThen, you will spin the Wheel again, "
			+"until you have made all your spins.")
		showButton("I see, "+respectTitle+".")
		show("If the mood takes me, I might decide that a spin is a 'bonus round', which means anything you spin is "
			+"multiplied by "+bonusMultiplier+"!\n\n"
			+"I might also decide, if I think you need it, to add extra spins for you to make.\n\n"
			+"I guess it depends how well you take your spankings... and how mean I'm feeling!")
		showButton("Gulp!")
	}
	if(gameMode==2) {
		show("'"+gamename+"' is a spanking quiz game where spinning a prize wheel determines your penalties.")
		showButton("Sounds interesting, "+respectTitle+".")
		if(categoryMode && pickCategory)
			show("Before we start, you will pick a topic to answer questions from.")
		else if(categoryMode)
			show("Before we start, you will be assigned a random topic to answer questions from.")
		if(categoryMode)
			showButton("Yes, "+respectTitle+".")
		show("The game is played in rounds.\n\nEach round, you will spin the Wheel of Discipline.\n\n"
			+"This spin will tell you the implement you will be spanked with (the wheel's outer ring), "
			+"and how many spanks you will receive (the wheel's inner ring).")
		showButton("A spanking, "+respectTitle+"?")
		show("Each round, you will be asked a question.\n\nIf you answer correctly, you will win "+gamePointsRound+" points "
			+"and won't get spanked.\n\n"
			+"If you answer incorrectly, you gain no points and will receive the spanking that you spun on the wheel.")
		showButton("I understand, "+respectTitle+".")
		if(bankruptMode) {
			show("Also, whenever you get a question wrong, not only will you be spanked, but your points reset to zero!")
			showButton("Yes, "+respectTitle+".")
		}
		show("This continues for each round.\n\nWe will play a total of "+gameRoundsMax+" rounds before the game is over.")
		showButton("I see, "+respectTitle+".")
		show("Also, each round has a random "+bonusRoundChance+" in 5 chance of being a 'bonus round'.\n\n"
			+"During a bonus round, any points or spanks you earn are multiplied by "+bonusMultiplier+"!")
		showButton("Yes, "+respectTitle+".")
		show("At the end of the game, however many points you've scored is how many strokes you can wank for me with.\n\n"
			+"However, if you end the game with 0 points, you will get a punishment spin on the wheel with the number of "
			+"spanks multiplied by "+doubleMultiplier+"!")
		showButton("Gulp!")
		show("One last thing: when answering questions, spelling matters but capitalization does not ('madonna' is the same as 'Madonna').\n\n"
			+"Most questions require a one or two word answer (with a single space between words). Names should be full names unless specified.\n\n"
			+"When an answer involves a number, enter it as digits rather than words ('38' instead of 'thirty-eight').")
		showButton("I understand, "+respectTitle+".")
	}
}

//Implement sound assignments
def setImplementSound = {
	if(spankImplement=="hairbrush") spankSound = "smack"
	else if(spankImplement=="paddle hairbrush") spankSound = "smack"
	else if(spankImplement=="plastic hairbrush") spankSound = "slap"
	else if(spankImplement=="ruler") spankSound = "whap"
	else if(spankImplement=="spatula") spankSound = "slap"
	else if(spankImplement=="wooden spatula") spankSound = "slap"
	else if(spankImplement=="flyswatter") spankSound = "slap"
	else if(spankImplement=="wooden spoon") spankSound = "whap"
	else if(spankImplement=="bathbrush") spankSound = "whack"
	else if(spankImplement=="slipper") spankSound = "smack"
	else if(spankImplement=="sandal") spankSound = "smack"
	else if(spankImplement=="plimsoll") spankSound = "smack"
	else if(spankImplement=="sneaker") spankSound = "smack"
	else if(spankImplement=="leather slapper") spankSound = "slap"
	else if(spankImplement=="leather paddle") spankSound = "slap"
	else if(spankImplement=="table tennis bat") spankSound = "smack"
	else if(spankImplement=="paddleball bat") spankSound = "smack"
	else if(spankImplement=="battledore bat") spankSound = "whack"
	else if(spankImplement=="beach tennis bat") spankSound = "smack"
	else if(spankImplement=="paddle") spankSound = "whack"
	else if(spankImplement=="paddle with holes") spankSound = "whack"
	else if(spankImplement=="lexan paddle") spankSound = "whack"
	else if(spankImplement=="plastic paddle") spankSound = "smack"
	else if(spankImplement=="rubber paddle") spankSound = "smack"
	else if(spankImplement=="strap") spankSound = "belt"
	else if(spankImplement=="studded strap") spankSound = "belt"
	else if(spankImplement=="loop strap") spankSound = "slap"
	else if(spankImplement=="belt") spankSound = "belt"
	else if(spankImplement=="tawse") spankSound = "flog"
	else if(spankImplement=="cane") spankSound = "thwack"
	else if(spankImplement=="judicial cane") spankSound = "thwack"
	else if(spankImplement=="duster handle") spankSound = "thwack"
	else if(spankImplement=="short cane") spankSound = "thwack"
	else if(spankImplement=="plastic cane") spankSound = "thwack"
	else if(spankImplement=="loop cane") spankSound = "thwack"
	else if(spankImplement=="riding crop") spankSound = "thwip"
	else if(spankImplement=="birch rod") spankSound = "thwip"
	else if(spankImplement=="curtain rod") spankSound = "thwip"
	else if(spankImplement=="switch") spankSound = "thwip"
	else if(spankImplement=="rugbeater") spankSound = "thwack"
	else if(spankImplement=="martinet") spankSound = "thwip"
	else if(spankImplement=="flogger") spankSound = "flog"
	else if(spankImplement=="cat-o-nine-tails") spankSound = "flog"
	else if(spankImplement=="whip") spankSound = "flog"
	else spankSound="smack"
}

def setImplementSounds = {
	spankImplement = slot1Implement
	setImplementSound()
	slot2ImplementSound = spankSound
	spankImplement = slot2Implement
	setImplementSound()
	slot2ImplementSound = spankSound
	spankImplement = slot3Implement
	setImplementSound()
	slot3ImplementSound = spankSound
	spankImplement = slot4Implement
	setImplementSound()
	slot4ImplementSound = spankSound
	spankImplement = slot5Implement
	setImplementSound()
	slot5ImplementSound = spankSound
	spankImplement = slot6Implement
	setImplementSound()
	slot6ImplementSound = spankSound
	spankImplement = slot7Implement
	setImplementSound()
	slot7ImplementSound = spankSound
	spankImplement = slot8Implement
	setImplementSound()
	slot8ImplementSound = spankSound
	spankImplement = slot9Implement
	setImplementSound()
	slot9ImplementSound = spankSound
}

//Mistress chooses implements
def pickImplementsMistress = {
	//Wheel slot 1 implement
	slot1Implement = "hairbrush"
	slot1Swats1 = 20
	slot1Swats2 = 30
	slot1Swats3 = 50
	//Wheel slot 2 implement
	slot2Implement = "strap"
	slot2Swats1 = 10
	slot2Swats2 = 20
	//Wheel slot 3 implement
	slot3Implement = "ruler"
	slot3Swats1 = 50
	slot3Swats2 = 75
	//Wheel slot 4 implement
	slot4Implement = "cane"
	slot4Swats1 = 3
	slot4Swats2 = 6
	//Wheel slot 5 implement
	slot5Implement = "wooden spoon"
	slot5Swats1 = 15
	slot5Swats2 = 25
	//Wheel slot 6 implement
	slot6Implement = "paddle"
	slot6Swats1 = 20
	slot6Swats2 = 25
	//Wheel slot 7 implement
	slot7Implement = "paddle with holes"
	slot7Swats1 = 15
	slot7Swats2 = 20
	//Wheel slot 8 implement
	slot8Implement = "slipper"
	slot8Swats1 = 25
	slot8Swats2 = 50
	//Wheel slot 9 implement
	slot9Implement = "paddle"
	slot9Swats1 = 10
	slot9Swats2 = 15
}
//REMOVE WHEN DEBUGGING (FROM HERE...)
//Custom wheel
def loadCustomWheel = {
	slot1Implement = loadString("Banjo.wheelofdiscipline.slot1Implement")
	slot1Swats1 = loadInteger("Banjo.wheelofdiscipline.slot1Swats1")
	slot1Swats2 = loadInteger("Banjo.wheelofdiscipline.slot1Swats2")
	slot1Swats3 = loadInteger("Banjo.wheelofdiscipline.slot1Swats3")
	slot2Implement = loadString("Banjo.wheelofdiscipline.slot2Implement")
	slot2Swats1 = loadInteger("Banjo.wheelofdiscipline.slot2Swats1")
	slot2Swats2 = loadInteger("Banjo.wheelofdiscipline.slot2Swats2")
	slot3Implement = loadString("Banjo.wheelofdiscipline.slot3Implement")
	slot3Swats1 = loadInteger("Banjo.wheelofdiscipline.slot3Swats1")
	slot3Swats2 = loadInteger("Banjo.wheelofdiscipline.slot3Swats2")
	slot4Implement = loadString("Banjo.wheelofdiscipline.slot4Implement")
	slot4Swats1 = loadInteger("Banjo.wheelofdiscipline.slot4Swats1")
	slot4Swats2 = loadInteger("Banjo.wheelofdiscipline.slot4Swats2")
	slot5Implement = loadString("Banjo.wheelofdiscipline.slot5Implement")
	slot5Swats1 = loadInteger("Banjo.wheelofdiscipline.slot5Swats1")
	slot5Swats2 = loadInteger("Banjo.wheelofdiscipline.slot5Swats2")
	slot6Implement = loadString("Banjo.wheelofdiscipline.slot6Implement")
	slot6Swats1 = loadInteger("Banjo.wheelofdiscipline.slot6Swats1")
	slot6Swats2 = loadInteger("Banjo.wheelofdiscipline.slot6Swats2")
	slot7Implement = loadString("Banjo.wheelofdiscipline.slot7Implement")
	slot7Swats1 = loadInteger("Banjo.wheelofdiscipline.slot7Swats1")
	slot7Swats2 = loadInteger("Banjo.wheelofdiscipline.slot7Swats2")
	slot8Implement = loadString("Banjo.wheelofdiscipline.slot8Implement")
	slot8Swats1 = loadInteger("Banjo.wheelofdiscipline.slot8Swats1")
	slot8Swats2 = loadInteger("Banjo.wheelofdiscipline.slot8Swats2")
	slot9Implement = loadString("Banjo.wheelofdiscipline.slot9Implement")
	slot9Swats1 = loadInteger("Banjo.wheelofdiscipline.slot9Swats1")
	slot9Swats2 = loadInteger("Banjo.wheelofdiscipline.slot9Swats2")
}

def saveCustomWheel = {
	save("Banjo.wheelofdiscipline.slot1Implement",slot1Implement)
	save("Banjo.wheelofdiscipline.slot1Swats1",slot1Swats1)
	save("Banjo.wheelofdiscipline.slot1Swats2",slot1Swats2)
	save("Banjo.wheelofdiscipline.slot1Swats3",slot1Swats3)
	save("Banjo.wheelofdiscipline.slot2Implement",slot2Implement)
	save("Banjo.wheelofdiscipline.slot2Swats1",slot2Swats1)
	save("Banjo.wheelofdiscipline.slot2Swats2",slot2Swats2)
	save("Banjo.wheelofdiscipline.slot3Implement",slot3Implement)
	save("Banjo.wheelofdiscipline.slot3Swats1",slot3Swats1)
	save("Banjo.wheelofdiscipline.slot3Swats2",slot3Swats2)
	save("Banjo.wheelofdiscipline.slot4Implement",slot4Implement)
	save("Banjo.wheelofdiscipline.slot4Swats1",slot4Swats1)
	save("Banjo.wheelofdiscipline.slot4Swats2",slot4Swats2)
	save("Banjo.wheelofdiscipline.slot5Implement",slot5Implement)
	save("Banjo.wheelofdiscipline.slot5Swats1",slot5Swats1)
	save("Banjo.wheelofdiscipline.slot5Swats2",slot5Swats2)
	save("Banjo.wheelofdiscipline.slot6Implement",slot6Implement)
	save("Banjo.wheelofdiscipline.slot6Swats1",slot6Swats1)
	save("Banjo.wheelofdiscipline.slot6Swats2",slot6Swats2)
	save("Banjo.wheelofdiscipline.slot7Implement",slot7Implement)
	save("Banjo.wheelofdiscipline.slot7Swats1",slot7Swats1)
	save("Banjo.wheelofdiscipline.slot7Swats2",slot7Swats2)
	save("Banjo.wheelofdiscipline.slot8Implement",slot8Implement)
	save("Banjo.wheelofdiscipline.slot8Swats1",slot8Swats1)
	save("Banjo.wheelofdiscipline.slot8Swats2",slot8Swats2)
	save("Banjo.wheelofdiscipline.slot9Implement",slot9Implement)
	save("Banjo.wheelofdiscipline.slot9Swats1",slot9Swats1)
	save("Banjo.wheelofdiscipline.slot9Swats2",slot9Swats2)
	save("Banjo.wheelofdiscipline.customwheel",true)
}

//Player chooses implements
def pickImplementsPlayer = {
	slot1Implement = getString("Enter the implement for wheel spot 1 (of 9):", slot1Implement)
	slot1Swats1 = getInteger("Enter the first set of swats for the "+slot1Implement+":", slot1Swats1)
	slot1Swats2 = getInteger("Enter the second set of swats for the "+slot1Implement+":", slot1Swats2)
	slot1Swats3 = getInteger("Enter the third set of swats for the "+slot1Implement+":", slot1Swats3)
	slot2Implement = getString("Enter the implement for wheel spot 2 (of 9):", slot2Implement)
	slot2Swats1 = getInteger("Enter the first set of swats for the "+slot2Implement+":", slot2Swats1)
	slot2Swats2 = getInteger("Enter the second set of swats for the "+slot2Implement+":", slot2Swats2)
	slot3Implement = getString("Enter the implement for wheel spot 3 (of 9):", slot3Implement)
	slot3Swats1 = getInteger("Enter the first set of swats for the "+slot3Implement+":", slot3Swats1)
	slot3Swats2 = getInteger("Enter the second set of swats for the "+slot3Implement+":", slot3Swats2)
	slot4Implement = getString("Enter the implement for wheel spot 4 (of 9):", slot4Implement)
	slot4Swats1 = getInteger("Enter the first set of swats for the "+slot4Implement+":", slot4Swats1)
	slot4Swats2 = getInteger("Enter the second set of swats for the "+slot4Implement+":", slot4Swats2)
	slot5Implement = getString("Enter the implement for wheel spot 5 (of 9):", slot5Implement)
	slot5Swats1 = getInteger("Enter the first set of swats for the "+slot5Implement+":", slot5Swats1)
	slot5Swats2 = getInteger("Enter the second set of swats for the "+slot5Implement+":", slot5Swats2)
	slot6Implement = getString("Enter the implement for wheel spot 6 (of 9):", slot6Implement)
	slot6Swats1 = getInteger("Enter the first set of swats for the "+slot6Implement+":", slot6Swats1)
	slot6Swats2 = getInteger("Enter the second set of swats for the "+slot6Implement+":", slot6Swats2)
	slot7Implement = getString("Enter the implement for wheel spot 7 (of 9):", slot7Implement)
	slot7Swats1 = getInteger("Enter the first set of swats for the "+slot7Implement+":", slot7Swats1)
	slot7Swats2 = getInteger("Enter the second set of swats for the "+slot7Implement+":", slot7Swats2)
	slot8Implement = getString("Enter the implement for wheel spot 8 (of 9):", slot8Implement)
	slot8Swats1 = getInteger("Enter the first set of swats for the "+slot8Implement+":", slot8Swats1)
	slot8Swats2 = getInteger("Enter the second set of swats for the "+slot8Implement+":", slot8Swats2)
	slot9Implement = getString("Enter the implement for wheel spot 9 (of 9):", slot9Implement)
	slot9Swats1 = getInteger("Enter the first set of swats for the "+slot9Implement+":", slot9Swats1)
	slot9Swats2 = getInteger("Enter the second set of swats for the "+slot9Implement+":", slot9Swats2)
	saveCustomWheel()
}

//Implement selection
def pickImplementsChoice = {
	if(loadBoolean("Banjo.wheelofdiscipline.customwheel"))
		loadCustomWheel()
	if(getBoolean("Do you want to customize the Wheel of Discipline?",
	"Yes","No")) pickImplementsPlayer()
	else pickImplementsMistress()
}
//REMOVE WHEN DEBUGGING (... TO HERE)
def pickImplements = {
	pickImplementsChoice() //REMOVE FOR DEBUGGING
//	pickImplementsMistress() //ADD FOR DEBUGGING
	setImplementSounds()
	save("Banjo.wheelofdiscipline.implements_set",true)
	def safeSpotText = ""
	if(safeChance) safeSpotText = "\n\tsafe\t : \tno spanking."
	show("The Wheel of Discipline looks like this:\n"
		+"\n\t"+slot1Implement+"\t : \t"+slot1Swats1+"/"+slot1Swats2+"/"+slot1Swats3+" spanks."
		+"\n\t"+slot2Implement+"\t : \t"+slot2Swats1+"/"+slot2Swats2+" spanks."
		+"\n\t"+slot3Implement+"\t : \t"+slot3Swats1+"/"+slot3Swats2+" spanks."
		+"\n\t"+slot4Implement+"\t : \t"+slot4Swats1+"/"+slot4Swats2+" spanks."
		+"\n\t"+slot5Implement+"\t : \t"+slot5Swats1+"/"+slot5Swats2+" spanks."
		+"\n\t"+slot6Implement+"\t : \t"+slot6Swats1+"/"+slot6Swats2+" spanks."
		+"\n\t"+slot7Implement+"\t : \t"+slot7Swats1+"/"+slot7Swats2+" spanks."
		+"\n\t"+slot8Implement+"\t : \t"+slot8Swats1+"/"+slot8Swats2+" spanks."
		+"\n\t"+slot9Implement+"\t : \t"+slot9Swats1+"/"+slot9Swats2+" spanks."
		+""+safeSpotText+"")
	showButton("Ready, "+respectTitle+".")
}

//Win points
def addPoints = {
	int pointsWon = gamePointsRound
	if(bonusRound)
		pointsWon = gamePointsRound * bonusMultiplier
	playSoundScore()
	show("You get "+pointsWon+" points!")
	points = points + pointsWon
	wait(3)
}

//Bankrupt points
def bankruptPoints = {
	points = 0
	playSoundBankrupt()
	show("I'm afraid your points go back to 0 now, too.")
	wait(3)
}

//Taunts
def getTauntSpin = {
	def tauntSpinLimit = 8
	def tauntSpinArray = ["Round and round and round she goes...",
		"Does that sound make you scared?",
		"Oooh, I hope it's something painful...",
		"Let's see what our lucky "+boygirl+" will get...",
		"Here it comes...",
		"Watch it spin!",
		"Spin that wheel!",
		"I wonder what it will be?"]
	tauntSpin = tauntSpinArray[getRandom(tauntSpinLimit)]
}

def getTauntPre = {
	def tauntPreLimit = 5
	def tauntPreArray = ["Ouch!",
		"Ouchies!",
		"That's going to sting something awful!",
		"Awww! You poor thing!",
		"Someone's going to be crying soon!"]
	if(spinSpanks<=6) {
		tauntPreArray = tauntPreArray + ["Ow! That's going to leave marks, I bet!",
			"Ooooh! Nasty!"]
		tauntPreLimit = tauntPreLimit + 2
	}
	if(spinSpanks>=50) {
		tauntPreArray = tauntPreArray + ["Yeowch! That's a whole complete spanking!",
			"Oooh! That's a real thrashing, isn't it?"]
		tauntPreLimit = tauntPreLimit + 2
	}
	if(spinImplement=="safe") {
		tauntPreArray = ["Lucky for you, young "+manlady+"!",
			"How disappointing!",
			"Lucky "+boygirl+"!"]
		tauntPreLimit = 3
	}
	tauntPre = tauntPreArray[getRandom(tauntPreLimit)]
}

def getTauntPost = {
	def tauntPostLimit = 5
	def tauntPostArray = ["Aww! Did that hurt, little "+boygirl+"?",
		"Stings, huh, "+boygirl+"?",
		"You'll be feeling that for a while, I bet!",
		"Are those tears in your eyes, you big baby?",
		"Is your bottom burning, young "+manlady+"?"]
	tauntPost = tauntPostArray[getRandom(tauntPostLimit)]
}

def getTauntSpank = {
	def tauntSpankLimit = 3
	def tauntSpankArray = ["Spank that naughty bottom, young "+manlady+"! Hard!",
		"Spanky, spanky! Ha ha ha!",
		"Hard spanks, naughty "+boygirl+"! I want that bottom stinging!"]
	tauntSpank = tauntSpankArray[getRandom(tauntSpankLimit)]
}

//Wheel spin for implement
def wheelSpinIt = {
	show("Let's give that wheel a big spin!")
	getTauntSpin()
	showButton("(Spin the wheel)")
	show(""+tauntSpin+"")
	playSoundWheelSpin()
	def wheelSpin
	if(safeChance)
		wheelSpin = getRandom(20)+1
	else
		wheelSpin = getRandom(19)+1
	if(wheelSpin<=3) {
		spinImplement = slot1Implement
		spinImplementSound = slot1ImplementSound
	} else if(wheelSpin<=5) {
		spinImplement = slot2Implement
		spinImplementSound = slot2ImplementSound
	} else if(wheelSpin<=7) {
		spinImplement = slot3Implement
		spinImplementSound = slot3ImplementSound
	} else if(wheelSpin<=9) {
		spinImplement = slot4Implement
		spinImplementSound = slot4ImplementSound
	} else if(wheelSpin<=11) {
		spinImplement = slot5Implement
		spinImplementSound = slot5ImplementSound
	} else if(wheelSpin<=13) {
		spinImplement = slot6Implement
		spinImplementSound = slot6ImplementSound
	} else if(wheelSpin<=15) {
		spinImplement = slot7Implement
		spinImplementSound = slot7ImplementSound
	} else if(wheelSpin<=17) {
		spinImplement = slot8Implement
		spinImplementSound = slot8ImplementSound
	} else if(wheelSpin<=19) {
		spinImplement = slot9Implement
		spinImplementSound = slot9ImplementSound
	} else if(wheelSpin==20) {
		spinImplement = "safe"
	}
	if(wheelSpin==1) spinSpanks = slot1Swats1
	else if(wheelSpin==2) spinSpanks = slot1Swats2
	else if(wheelSpin==3) spinSpanks = slot1Swats3
	else if(wheelSpin==4) spinSpanks = slot2Swats1
	else if(wheelSpin==5) spinSpanks = slot2Swats2
	else if(wheelSpin==6) spinSpanks = slot3Swats1
	else if(wheelSpin==7) spinSpanks = slot3Swats2
	else if(wheelSpin==8) spinSpanks = slot4Swats1
	else if(wheelSpin==9) spinSpanks = slot4Swats2
	else if(wheelSpin==10) spinSpanks = slot5Swats1
	else if(wheelSpin==11) spinSpanks = slot5Swats2
	else if(wheelSpin==12) spinSpanks = slot6Swats1
	else if(wheelSpin==13) spinSpanks = slot6Swats2
	else if(wheelSpin==14) spinSpanks = slot7Swats1
	else if(wheelSpin==15) spinSpanks = slot7Swats2
	else if(wheelSpin==16) spinSpanks = slot8Swats1
	else if(wheelSpin==17) spinSpanks = slot8Swats2
	else if(wheelSpin==18) spinSpanks = slot9Swats1
	else if(wheelSpin==19) spinSpanks = slot9Swats2
	else if(wheelSpin==20) spinSpanks = 0
	show("And the wheel shows...")
	wait(2)
	getTauntPre()
	if(losingRound) {
		totalSpanks = spinSpanks * doubleMultiplier
		tauntPre = "But since this is your penalty spin for ending the game on 0 points, you get "+totalSpanks+" spanks instead!\n\n"+tauntPre+""
	}
	else if(bonusRound) {
		totalSpanks = spinSpanks * bonusMultiplier
		tauntPre = "But since this is a bonus round, that means you get "+totalSpanks+" spanks!\n\n"+tauntPre+""
	}
	else
		totalSpanks = spinSpanks
	if(spinImplement=="safe") {
		show("Safe!\n\n"
			+""+tauntPre+"")
		showButton("Phew!")
	}
	else {
		show(""+spinSpanks+" with the "+spinImplement+"!\n\n"
			+""+tauntPre+"")
		showButton("Gulp!")
	}
}

//Get Spanked
def getSpanked = {
	setImageSpank()
	show("Pick up the "+spinImplement+", pull your underwear down and bend over.\n\n"
		+"You have "+totalSpanks+" swats coming to you.")
	showButton("I have it, "+respectTitle+".")
	spankSound = spinImplementSound
	def tempo = 2
	if(totalSpanks<=6)
		tempo = 3.5
	else if(totalSpanks<=10)
		tempo = 3
	else if(totalSpanks>=50)
		tempo = 1.5
	else if(totalSpanks<50)
		tempo = 1
	getTauntSpank()
	spank(tauntSpank,totalSpanks,tempo)
	getTauntPost()
	setImageGame()
	show(""+tauntPost+"")
	wait(6)
	if(gameMode==2) {
		show("Pull that underwear back up!")
		wait(3)
	}
}

//Spin announce
def spinAnnounce = {
	show("Spin number "+wheelSpins+"...")
	wait(3)
}

//Bonus round
def bonusRoundCheck = {
	def bonusRoundRandom = getRandom(5)+1
	if(bonusRoundRandom<=bonusRoundChance) {
		if(gameMode==1)
			show("Bonus round!\n\nThat means whatever you spin is multiplied by "+bonusMultiplier+"!")
		else
			show("Bonus round!\n\nThat means any points you earn this round are multiplied by "+bonusMultiplier+"!\n\n"
				+"However, you also get double the spanks!")
		bonusRound = true
	}
	else
		bonusRound = false
}

//Bonus spin
def bonusSpin = {
	setImageGame()
	show("I think you need a bonus spin, young "+manlady+"!")
	wait(3)
	wheelSpinIt()
	getSpanked()
}

def bonusSpinCheck = {
	def bonusSpinRandom = getRandom(5)+1
	if(bonusSpinRandom<=bonusSpinChance)
		bonusSpin()
}

//Wheel total spins
def setWheelTotalSpins = {
	if(wheelTotalSpinsRandom) {
//		wheelTotalSpins = getRandom(6)+1 //ADD FOR DEBUGGING
		wheelTotalSpins = getRandom(wheelTotalSpinsMax)+1 //REMOVE FOR DEBUGGING
		if(wheelTotalSpins<wheelTotalSpinsMin)
			wheelTotalSpins = wheelTotalSpinsMin
	}
	else {
		wheelTotalSpins = wheelTotalSpinsFixed
	}
}

//Strip player
def stripPlayer = {
	if(gameMode==2)
		show("For this game, you will be playing in your underwear. Take off everything else before we start.\n\nLet me know when you're done.")
	else
		show("Before we start, since you're going to be spanked, you should remove all your clothes. Everything off!\n\nLet me know when you're done.")
	showButton("Done, "+respectTitle+".")
}

// Player reward
def playerReward = {
	setImageGame()
	show("Alright, time for your prize!"
		+"\n\nTake off your underwear, young "+manlady+".")
	showButton("Done, "+respectTitle+".")
	show("Now, you're going to stroke yourself for me...")
	showButton("Ready, "+respectTitle+".")

	def totalStrokes = points
	def strokeRounds = (int) totalStrokes / 50
	def remainingStrokes = totalStrokes % 50

	def firstThird = (int) strokeRounds*(1.0/3)+1
	def finalThird = (int) strokeRounds*(2.0/3)+1

	def strokeTime = 1

	def message = "Slow strokes."

	def i=1
	while(i <= strokeRounds)
	{
		if(i == firstThird && i >= 2)
		{
			setImageGame()
			strokeTime = 0.75
			message = "Medium strokes."
		}
		else if(i==finalThird && i>=4)
		{
			setImageGame()
			strokeTime = 0.5
			message = "Faster strokes."
		}
		else if(i == strokeRounds && i > 5)
		{
			setImageGame()
			strokeTime = 0.25
			message = "Fast strokes!"
		}
		if(i == strokeRounds) stroke(message,50+remainingStrokes,strokeTime)
		else stroke(message,50,strokeTime)
		i++
	}
	if(strokeRounds == 0)
	{
		strokeTime = 2
		setImageGame()
		show("Poor baby! You couldn't even earn 50 strokes!"+
			"\n\nDon't worry, I will make this little wank session last for you.")
		wait(5)
		setImageGame()
		stroke("Make sure you savor these!",remainingStrokes,strokeTime)
	}
	show("Did you enjoy that, "+player+"?")
	showButton("Thank you, "+respectTitle+".")
}

//Select question category
def getCategory = {
	//Setup
	def readtext
	def readlimit
	def lines
	//Categories List
	int categoriesLimit = 6
	def categoriesArray = ["World","Movie","Food","Science","Music","Animal"]
	//World
	int limitWorld = 0
	readtext = new File("scripts/Banjo/Quiz/world_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitWorld ++
	def questionsWorld = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/world_a.txt")
	def answersWorld = readtext.readLines()
	//Movie
	int limitMovie = 0
	readtext = new File("scripts/Banjo/Quiz/movie_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitMovie ++
	def questionsMovie = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/movie_a.txt")
	def answersMovie = readtext.readLines()
	//Food
	int limitFood = 0
	readtext = new File("scripts/Banjo/Quiz/food_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitFood ++
	def questionsFood = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/food_a.txt")
	def answersFood = readtext.readLines()
	//Science
	int limitScience = 0
	readtext = new File("scripts/Banjo/Quiz/science_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitScience ++
	def questionsScience = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/science_a.txt")
	def answersScience = readtext.readLines()
	//Music
	int limitMusic = 0
	readtext = new File("scripts/Banjo/Quiz/music_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitMusic ++
	def questionsMusic = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/music_a.txt")
	def answersMusic = readtext.readLines()
	//Animal
	int limitAnimal = 0
	readtext = new File("scripts/Banjo/Quiz/animal_q.txt")
	lines = readtext.readLines()
	for(def line : lines)
		limitAnimal ++
	def questionsAnimal = readtext.readLines()
	readtext = new File("scripts/Banjo/Quiz/animal_a.txt")
	def answersAnimal = readtext.readLines()
	//Select question category
	def category
	def categoryPick
	if(!categoryMode) {
		questionLimit = (int) limitWorld + limitMovie + limitFood + limitScience + limitMusic + limitAnimal
		questionArray = questionsWorld + questionsMovie + questionsFood + questionsScience + questionsMusic + questionsAnimal
		answerArray = answersWorld + answersMovie + answersFood + answersScience + answersMusic + answersAnimal
	}
	else {
		if(pickCategory)
			categoryPick = getSelectedValue("Choose your category:", categoriesArray)
		else
			categoryPick = getRandom(categoriesLimit)
		category = categoriesArray[categoryPick]
		//Assign selected category to question array
		categoryPick = categoryPick + 1
		if(categoryPick==1) {
			questionLimit = limitWorld
			questionArray = questionsWorld
			answerArray = answersWorld
		}
		else if(categoryPick==2) {
			questionLimit = limitMovie
			questionArray = questionsMovie
			answerArray = answersMovie
		}
		else if(categoryPick==3) {
			questionLimit = limitFood
			questionArray = questionsFood
			answerArray = answersFood
		}
		else if(categoryPick==4) {
			questionLimit = limitScience
			questionArray = questionsScience
			answerArray = answersScience
		}
		else if(categoryPick==5) {
			questionLimit = limitMusic
			questionArray = questionsMusic
			answerArray = answersMusic
		}
		else if(categoryPick==6) {
			questionLimit = limitAnimal
			questionArray = questionsAnimal
			answerArray = answersAnimal
		}
		if(!pickCategory) {
			show("Today's category is:\n"+category+" Trivia.")
			wait(3)
		}
	}
}

//Ask a question
def askQuestion = {
	//Check if all questions have been asked
	if(questionLimit<1) {
		show("Oops! There are no questions left to ask! There must be an error somewhere...")
		wait(3)
		gameMode = 0
	}
	else {
		//Select random question
		def questionSelect = getRandom(questionLimit)
		def questionAsked = questionArray[questionSelect]
		def answerCorrect = answerArray[questionSelect]
		//Ask question
		def question = getString(""+questionAsked+"","")
		if(question.toLowerCase().contains(answerCorrect.toLowerCase())) {
			playSoundCorrect()
			show("Correct!")
			wait(3)
			correct = true
		}
		else {
			playSoundWrong()
			show("I'm sorry! That's the wrong answer!\n\n"
				+"The correct answer was '"+answerCorrect+"'.")
			wait(5)
			correct = false
		}
		//Remove question and answer so it can't be asked again
		questionArray.remove(questionAsked)
		answerArray.remove(answerCorrect)
		questionLimit --
	}
}

//Install Check
def installed = loadBoolean("Banjo.games.installed")
if(installed==null) {
	installed = false
	save("Banjo.games.installed",installed)
}

def coreScript = new File("scripts/Banjo/gamehub.groovy")
if(coreScript.exists()) {
	installed = true
	save("Banjo.games.installed",installed)
}
else {
	installed = false
	save("Banjo.games.installed",installed)
}
if(!installed) {
	show(null)
	setImage(null)
	if(getBoolean("CORE FILES NOT FOUND!\n\n"
		+"This game requires the download of a 'core' pack of opponents, images, sounds and files that is shared by other games in this series."
		+"To download the needed files, simply go to the SexScripts website script database and search for 'Game Hub' (or the script tag 'banjohub').\n\n"
		+"The script downloads can be found at:\n\n"
		+"http://ss.deviatenow.com/scripts.php\n\n"
		+"Apologies for the inconvenience!"
		+"", "Go to Webpage","Exit")) {
			if(isConnected()) {
				useUrl("http://ss.deviatenow.com/scripts.php")
				getString("Your internet browser should have opened the correct download page.\n\n"
					+"If not, please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
			else {
				getString("Cannot connect to the internet (your firewall may be blocking this operation)\n\n"
					+"Please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
		}
		show(null)
		setImage(null)
		if(loadBoolean("setting.newsetup")) {
			if(loadBoolean("setting.reload")) {
				return "system/welcome"
			}
			else {
				return "system/exit"
			}
		}
		else {
			return null
		}
}

//Start of script
show(null)
setImage(null)
opponentSelect()
show(null)
setImageMain()
wait(1)
intro()
doubleMultiplier = bonusMultiplier + bonusMultiplier
while(!quit) {
	gameMode = getSelectedValue("Select mode:", ["Punishment Mode", "Game Mode"])
	gameMode = gameMode + 1
	if(getBoolean("Do you want to review the rules?","Yes","I know them"))
	{
		rulesDisplay()
		while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
		{
			rulesDisplay()
		}
	}
	pickImplements()
	stripPlayer()
	while(gameMode==1) {
		show("Let's play!")
		wait(3)
		setWheelTotalSpins()
		show("You're getting "+wheelTotalSpins+" spins on the Wheel of Discipline.")
		showButton("Yes, "+respectTitle+".")
		while(wheelSpins<wheelTotalSpins) {
			wheelSpins = wheelSpins + 1
			setImageGame()
			spinAnnounce()
			bonusRoundCheck()
			wheelSpinIt()
			if(spinImplement!="safe")
				getSpanked()
		}
		bonusSpinCheck()
		setImageGame()
		show("There we go! That's all your spins done!")
		wait(3)
		gameMode = 0
	}
	while(gameMode==2) {
		show("Let's play!")
		wait(3)
		getCategory()
		while(gameRound<gameRoundsMax) {
			gameRound = gameRound + 1
			def roundCall = "Round "+gameRound+""
			if(gameRound==gameRoundsMax)
				roundCall = "Final round"
			show(""+roundCall+"!\n\nYou currently have "+points+" points.")
			showButton("Ready, "+respectTitle+".")
			if(gameRound>1)
				bonusRoundCheck()
			if(bonusRound)
				showButton("Ready, "+respectTitle+".")
			wheelSpinIt()
			askQuestion()
			if(correct)
				addPoints()
			else {
				if(spinImplement=="safe") {
					show("Lucky for you the wheel landed on the safety spot!")
					wait(3)
				}
				else
					getSpanked()
				if(bankruptMode)
					bankruptPoints()
			}
			if(gameRound<gameRoundsMax) {
				show("Let's move to the next round.")
				wait(3)
			}
		}
		setImageGame()
		show("Game over!\n\nYou finished up with "+points+" points.")
		showButton("(Continue)")
		if(points==0) {
			losingRound = true
			show("Since you failed to end the game with any points, you now get a punishment spin... and this "
				+"one's results will be multiplied by "+doubleMultiplier+"!")
			wait(5)
			wheelSpinIt()
			if(spinImplement=="safe") {
				show("Oooh, now that was really lucky you spun the safe spot that time!")
				wait(3)
			} else {
				getSpanked()
			}
			losingRound = false
		}
		else
			playerReward()
		gameMode = 0
	}
	setImageMain()
	show(goodbye1)
	showButton("Goodbye, "+respectTitle+".")
	quit = true
}
setImage(null)
show(null)
def quitGame = true
if(loadBoolean("Banjo.games.hub")) {
	if(getBoolean("Return to Game Hub?","Yes","No")) {
		quitGame = false
		save("Banjo.games.hub",false)
		return "Banjo/gamehub"
	} else save("Banjo.games.hub",false)
}
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

//END OF SCRIPT
